/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "StarTracker.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void StarTrackerMeasurement_Initialize(StarTrackerMeasurement* pVal)
{
  *pVal = (StarTrackerMeasurement)
  {
    .attributes =
    {
      .timestamp = -9223372036854775807LL,
      .validity = sample_empty,
      .attributes = {
        .nCount = 0,    .arr =
        {

        }
      }
    },
    .position = {    .nCount = 1,    .arr =
      {
        0.00000000000000000000E+000
      }
    }
  };
}
#endif


flag StarTrackerMeasurement_IsConstraintValid(const StarTrackerMeasurement* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = SampleAttributes_IsConstraintValid(&pVal->attributes, pErrCode);
  if (ret)
    {
      ret = Quaterniond_IsConstraintValid(&pVal->position, pErrCode);

    }

  return ret;
}

flag StarTrackerMeasurement_Encode(const StarTrackerMeasurement* pVal, BitStream* pBitStrm, int* pErrCode,
                                   flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? StarTrackerMeasurement_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      /*Encode attributes */
      ret = SampleAttributes_Encode(&pVal->attributes, pBitStrm, pErrCode, FALSE);
      if (ret)
        {
          /*Encode position */
          ret = Quaterniond_Encode(&pVal->position, pBitStrm, pErrCode, FALSE);

        }
    }

  return ret;
}

flag StarTrackerMeasurement_Decode(StarTrackerMeasurement* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;

  /*Decode attributes */
  ret = SampleAttributes_Decode(&pVal->attributes, pBitStrm, pErrCode);
  if (ret)
    {
      /*Decode position */
      ret = Quaterniond_Decode(&pVal->position, pBitStrm, pErrCode);

    }


  return ret;
}

